"use strict";
this.name			= "Additional Cargo Space Adjustments Script";
this.author			= "ocz";
this.copyright		= "2015 ocz";
this.licence		= "CC BY-NC-SA 4.0";

this.playerBoughtEquipment = function(equipment) {
	
	if (equipment == "EQ_CARGOSPACEADJUST_1") {
		player.ship.cargoSpaceCapacity += 1;
		return;
	}
	if (equipment == "EQ_CARGOSPACEADJUST_2") {
		player.ship.removeEquipment("EQ_CARGOSPACEADJUST_1");
		player.ship.cargoSpaceCapacity += 1;
		return;
	}
	if (equipment == "EQ_CARGOSPACEADJUST_3") {
		player.ship.removeEquipment("EQ_CARGOSPACEADJUST_2");
		player.ship.cargoSpaceCapacity += 1;
	}
	
}

var aCSAAdjustCargo = function(inputCommodity, inputAmount) {
	
	var _amount = inputAmount;
	if (_amount < 0) _amount = 0;
	
	if (inputCommodity === "gem_stones") {
		var _tons = Math.floor(_amount/500000);
		if (_tons > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.gem_stones = _amount;
		return true;
	}
	if (inputCommodity === "gold") {
		var _tons = Math.floor((_amount + player.ship.manifest.platinum.quantity)/500);
		if (_tons > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.gold = _amount;
		return true;
	}
	if (inputCommodity === "platinum") {
		var _tons = Math.floor((_amount + player.ship.manifest.gold.quantity)/500);
		if (_tons > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.platinum = _amount;
		return true;
	}
	
	if (inputCommodity === "computers") {
		if ((_amount - player.ship.manifest.computers.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.computers = _amount;
		return true
	}
	if (inputCommodity === "furs") {
		if ((_amount - player.ship.manifest.furs.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.furs = _amount;
		return true
	}
	if (inputCommodity === "liquor_wines") {
		if ((_amount - player.ship.manifest.liquor_wines.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.liquor_wines = _amount;
		return true
	}
	if (inputCommodity === "luxuries") {
		if ((_amount - player.ship.manifest.luxuries.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.luxuries = _amount;
		return true
	}
	if (inputCommodity === "alloys") {
		if ((_amount - player.ship.manifest.alloys.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.alloys = _amount;
		return true
	}
	if (inputCommodity === "slaves") {
		if ((_amount - player.ship.manifest.slaves.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.slaves = _amount;
		return true
	}
	if (inputCommodity === "minerals") {
		if ((_amount - player.ship.manifest.minerals.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.minerals = _amount;
		return true
	}
	if (inputCommodity === "food") {
		if ((_amount - player.ship.manifest.food.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.food = _amount;
		return true
	}
	if (inputCommodity === "textiles") {
		if ((_amount - player.ship.manifest.textiles.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.textiles = _amount;
		return true
	}
	if (inputCommodity === "radioactives") {
		if ((_amount - player.ship.manifest.radioactives.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.radioactives = _amount;
		return true
	}
	if (inputCommodity === "machinery") {
		if ((_amount - player.ship.manifest.machinery.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.machinery = _amount;
		return true
	}
	if (inputCommodity === "narcotics") {
		if ((_amount - player.ship.manifest.narcotics.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.narcotics = _amount;
		return true
	}
	if (inputCommodity === "firearms") {
		if ((_amount - player.ship.manifest.firearms.quantity) > player.ship.cargoSpaceAvailable) {
			log("Not enough space for ''" + inputAmount + " " + inputCommodity + "''.");
			return false;
		}
		player.ship.manifest.firearms = _amount;
		return true
	}
	
	log("Commodity ''" + inputCommodity + "'' not recognized.");
	return false;
	
}

this.startUpComplete = function() {
	
	if (missionVariables.ACSA_max_cargo != null) {
		player.ship.cargoSpaceCapacity = missionVariables.ACSA_max_cargo;
	}
	
	if (missionVariables.ACSA_ship_manifest_list != null) {
		var _aCSAShipManifestList = missionVariables.ACSA_ship_manifest_list;
		var i, _s, _commodity, _quantity;
		_commodity = "";
		_quantity = "";
		for (i = 0; i < _aCSAShipManifestList.length; i++) {
			if (_aCSAShipManifestList[i] == "{" ) {
				i++;
				if (i+1 < _aCSAShipManifestList.length) _s = _aCSAShipManifestList[i] + _aCSAShipManifestList[i+1];
				if ( _s === "I:" ) {
					i += 2;
					_s = "";
					while (i < _aCSAShipManifestList.length && _aCSAShipManifestList[i] != "}") {
						_s += _aCSAShipManifestList[i];
						i++;
					}
					_commodity = _s;
				}
				else if ( _s === "Q:" ) {
					i += 2;
					_s = "";
					while (i < _aCSAShipManifestList.length && _aCSAShipManifestList[i] != "}") {
						_s += _aCSAShipManifestList[i];
						i++;
					}
					_quantity = _s;
				}
			}
			else if (_aCSAShipManifestList[i] == "]" ) {
				if (_commodity != "" && _quantity != "") {
					aCSAAdjustCargo(_commodity, _quantity);
					_commodity = "";
					_quantity = "";
				}
			}
		}	
	}
	
}

this.playerWillSaveGame = function () {
	
	missionVariables.ACSA_max_cargo = player.ship.cargoSpaceCapacity;
	
	var _aCSAShipManifestList = "---Do NOT edit this line!---[";
	var _mList = player.ship.manifest.list;
	var _m, i;
	for (i = 0; i < _mList.length; i++)
	{
		_m = _mList[i];
		_aCSAShipManifestList += "[{I:" + _m.commodity /*+ "}{N:" +_m.displayName + "}{C:" + _m.containers */+ "}{Q:" + _m.quantity/*  + "}{U:" +  _m.unit */ + "}]";
	}
	_aCSAShipManifestList += "]";
	missionVariables.ACSA_ship_manifest_list = _aCSAShipManifestList;
	
}